package com.jakubu9333.grammarManager.service;

import com.jakubu9333.grammarManager.FileType;


import com.jakubu9333.grammarManager.dao.XmlDataRepo;



import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;



/**
 * @author Jakub Uhlarik
 */
@Service
public class RuleService {


    private final XmlDataRepo xmlDataRepo;
    private final FileService fileService;

    @Autowired
    public RuleService(XmlDataRepo xmlDataRepo, FileService fileService) {
        this.xmlDataRepo = xmlDataRepo;
        this.fileService = fileService;
    }



    public String getRuleByLeft(String left, FileType format) {
        String xml = xmlDataRepo.getRuleByLeft(left);
        if (xml.isEmpty()){
            throw new ResponseStatusException(HttpStatus.NOT_FOUND,"rule with left side: "+left+" not found");
        }
        if (format== FileType.XML_SRGS){
            return xml;
        }
        return fileService.xmlToJSGF(xml,false);
    }
}
