package com.jakubu9333.grammarManager.unitTest;

import com.jakubu9333.grammarManager.dao.XmlDataRepo;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.TestPropertySource;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Jakub Uhlarik
 */
@SpringBootTest
@ActiveProfiles("test")
@TestPropertySource(properties = {"db.name=testDB"})
public class RepositoryTest {

    private XmlDataRepo xmlDataRepo;

    private final static String testXml= """
                 <grammar xmlns="http://www.w3.org/2001/06/grammar" version="1.0" xml:base="xd" root="sde" xml:lang="en">
                	<rule id="p">
                		<one-of>
                			<item>d
                </item>
                			<item>pred
                				<ruleref uri="#xd"/>zad
                			</item>
                		</one-of>
                	</rule>
                	<rule id="sde">
                		<item> mam rad zvuk 
                			<ruleref uri="#mirozbirka"/>  zvuk jabloní
                		</item>
                	</rule>
                	<!--comment -->
                </grammar>
             
                                """;

    private final static String testXml2= """
                 <?xml version='1.0'?>
                 <grammar
                	xmlns="http://www.w3.org/2001/06/grammar" version="1.0" xml:base="xd" root="sde" xml:lang="en">
                	<rule id="p">
                		<one-of>
                			<item>d
                </item>
                			<item>pred
                				<ruleref uri="#xd"/>zad
                			</item>
                		</one-of>
                	</rule>
                	<rule id="sde">
                		<item> mam rad zvuk 
                			<ruleref uri="#mirozbirka"/>  zvuk jabloní
                		</item>
                	</rule>
                	<!--comment -->
                </grammar>
              
                                """;

    @Autowired
    private RepositoryTest(XmlDataRepo xmlDataRepo) {
        this.xmlDataRepo = xmlDataRepo;
    }


    @Test
    public void testAdd() {
        String uid=xmlDataRepo.add(testXml);
        xmlDataRepo.delete(uid);
    }


    @Test
    public void testGetUID() {
        String uid = xmlDataRepo.add(testXml.trim());
        assertThat(xmlDataRepo.getByUid(uid).replaceAll("\r\n","\n")).isEqualTo(testXml.trim());
        xmlDataRepo.delete(uid);

    }

    @Test
    public void testGetName() {


    }

    @Test
    public void testGetRoot() {

    }

    @Test
    public void testGetRuleLeft() {

    }

}
